name: Test Other Platforms

on:
  push:
    branches:
      - '**'

  pull_request:

jobs:
  test-mac:
    runs-on: macos-latest

    steps:
      - uses: actions/setup-go@v4
        with:
          go-version: 1.18

      - uses: actions/checkout@v3

      - run: go run ./lib/utils/ci-test -timeout-each=2m

      - uses: actions/upload-artifact@v2
        if: ${{ always() }}
        with:
          name: cdp-log-macos
          path: tmp/cdp-log

  test-windows:
    runs-on: windows-latest

    steps:
      - uses: actions/setup-go@v4
        with:
          go-version: 1.18

      - uses: actions/checkout@v3

      - run: go run ./lib/utils/ci-test -timeout-each=2m

      - uses: actions/upload-artifact@v2
        if: ${{ always() }}
        with:
          name: cdp-log-windows
          path: tmp/cdp-log

  test-old-go:
    runs-on: ubuntu-latest

    steps:
      - uses: actions/setup-go@v4
        with:
          go-version: 1.13

      - uses: actions/checkout@v3

      # As long as the build works we don't have to run tests.
      - run: go build ./lib/examples/translator
